(function(n) {
"use strict";
"undefined" != typeof module && module.exports && !n["encoding-indexes"] && (n["encoding-indexes"] = require("./encoding-indexes.js")["encoding-indexes"]);
function e(n, e, r) {
return e <= n && n <= r;
}
var r = Math.floor;
function i(n) {
if (void 0 === n) return {};
if (n === Object(n)) return n;
throw TypeError("Could not convert argument to dictionary");
}
function t(n) {
for (var e = String(n), r = e.length, i = 0, t = []; i < r; ) {
var o = e.charCodeAt(i);
if (o < 55296 || o > 57343) t.push(o); else if (56320 <= o && o <= 57343) t.push(65533); else if (55296 <= o && o <= 56319) if (i === r - 1) t.push(65533); else {
var s = e.charCodeAt(i + 1);
if (56320 <= s && s <= 57343) {
var u = 1023 & o, a = 1023 & s;
t.push(65536 + (u << 10) + a);
i += 1;
} else t.push(65533);
}
i += 1;
}
return t;
}
function o(n) {
for (var e = "", r = 0; r < n.length; ++r) {
var i = n[r];
if (i <= 65535) e += String.fromCharCode(i); else {
i -= 65536;
e += String.fromCharCode(55296 + (i >> 10), 56320 + (1023 & i));
}
}
return e;
}
function s(n) {
return 0 <= n && n <= 127;
}
var u = s, a = -1;
function l(n) {
this.tokens = [].slice.call(n);
this.tokens.reverse();
}
l.prototype = {
endOfStream: function() {
return !this.tokens.length;
},
read: function() {
return this.tokens.length ? this.tokens.pop() : a;
},
prepend: function(n) {
if (Array.isArray(n)) for (var e = n; e.length; ) this.tokens.push(e.pop()); else this.tokens.push(n);
},
push: function(n) {
if (Array.isArray(n)) for (var e = n; e.length; ) this.tokens.unshift(e.shift()); else this.tokens.unshift(n);
}
};
var f = -1;
function c(n, e) {
if (n) throw TypeError("Decoder error");
return e || 65533;
}
function d(n) {
throw TypeError("The code point " + n + " could not be encoded.");
}
function h(n) {
n = String(n).trim().toLowerCase();
return Object.prototype.hasOwnProperty.call(p, n) ? p[n] : null;
}
var g = [ {
encodings: [ {
labels: [ "unicode-1-1-utf-8", "utf-8", "utf8" ],
name: "UTF-8"
} ],
heading: "The Encoding"
}, {
encodings: [ {
labels: [ "866", "cp866", "csibm866", "ibm866" ],
name: "IBM866"
}, {
labels: [ "csisolatin2", "iso-8859-2", "iso-ir-101", "iso8859-2", "iso88592", "iso_8859-2", "iso_8859-2:1987", "l2", "latin2" ],
name: "ISO-8859-2"
}, {
labels: [ "csisolatin3", "iso-8859-3", "iso-ir-109", "iso8859-3", "iso88593", "iso_8859-3", "iso_8859-3:1988", "l3", "latin3" ],
name: "ISO-8859-3"
}, {
labels: [ "csisolatin4", "iso-8859-4", "iso-ir-110", "iso8859-4", "iso88594", "iso_8859-4", "iso_8859-4:1988", "l4", "latin4" ],
name: "ISO-8859-4"
}, {
labels: [ "csisolatincyrillic", "cyrillic", "iso-8859-5", "iso-ir-144", "iso8859-5", "iso88595", "iso_8859-5", "iso_8859-5:1988" ],
name: "ISO-8859-5"
}, {
labels: [ "arabic", "asmo-708", "csiso88596e", "csiso88596i", "csisolatinarabic", "ecma-114", "iso-8859-6", "iso-8859-6-e", "iso-8859-6-i", "iso-ir-127", "iso8859-6", "iso88596", "iso_8859-6", "iso_8859-6:1987" ],
name: "ISO-8859-6"
}, {
labels: [ "csisolatingreek", "ecma-118", "elot_928", "greek", "greek8", "iso-8859-7", "iso-ir-126", "iso8859-7", "iso88597", "iso_8859-7", "iso_8859-7:1987", "sun_eu_greek" ],
name: "ISO-8859-7"
}, {
labels: [ "csiso88598e", "csisolatinhebrew", "hebrew", "iso-8859-8", "iso-8859-8-e", "iso-ir-138", "iso8859-8", "iso88598", "iso_8859-8", "iso_8859-8:1988", "visual" ],
name: "ISO-8859-8"
}, {
labels: [ "csiso88598i", "iso-8859-8-i", "logical" ],
name: "ISO-8859-8-I"
}, {
labels: [ "csisolatin6", "iso-8859-10", "iso-ir-157", "iso8859-10", "iso885910", "l6", "latin6" ],
name: "ISO-8859-10"
}, {
labels: [ "iso-8859-13", "iso8859-13", "iso885913" ],
name: "ISO-8859-13"
}, {
labels: [ "iso-8859-14", "iso8859-14", "iso885914" ],
name: "ISO-8859-14"
}, {
labels: [ "csisolatin9", "iso-8859-15", "iso8859-15", "iso885915", "iso_8859-15", "l9" ],
name: "ISO-8859-15"
}, {
labels: [ "iso-8859-16" ],
name: "ISO-8859-16"
}, {
labels: [ "cskoi8r", "koi", "koi8", "koi8-r", "koi8_r" ],
name: "KOI8-R"
}, {
labels: [ "koi8-ru", "koi8-u" ],
name: "KOI8-U"
}, {
labels: [ "csmacintosh", "mac", "macintosh", "x-mac-roman" ],
name: "macintosh"
}, {
labels: [ "dos-874", "iso-8859-11", "iso8859-11", "iso885911", "tis-620", "windows-874" ],
name: "windows-874"
}, {
labels: [ "cp1250", "windows-1250", "x-cp1250" ],
name: "windows-1250"
}, {
labels: [ "cp1251", "windows-1251", "x-cp1251" ],
name: "windows-1251"
}, {
labels: [ "ansi_x3.4-1968", "ascii", "cp1252", "cp819", "csisolatin1", "ibm819", "iso-8859-1", "iso-ir-100", "iso8859-1", "iso88591", "iso_8859-1", "iso_8859-1:1987", "l1", "latin1", "us-ascii", "windows-1252", "x-cp1252" ],
name: "windows-1252"
}, {
labels: [ "cp1253", "windows-1253", "x-cp1253" ],
name: "windows-1253"
}, {
labels: [ "cp1254", "csisolatin5", "iso-8859-9", "iso-ir-148", "iso8859-9", "iso88599", "iso_8859-9", "iso_8859-9:1989", "l5", "latin5", "windows-1254", "x-cp1254" ],
name: "windows-1254"
}, {
labels: [ "cp1255", "windows-1255", "x-cp1255" ],
name: "windows-1255"
}, {
labels: [ "cp1256", "windows-1256", "x-cp1256" ],
name: "windows-1256"
}, {
labels: [ "cp1257", "windows-1257", "x-cp1257" ],
name: "windows-1257"
}, {
labels: [ "cp1258", "windows-1258", "x-cp1258" ],
name: "windows-1258"
}, {
labels: [ "x-mac-cyrillic", "x-mac-ukrainian" ],
name: "x-mac-cyrillic"
} ],
heading: "Legacy single-byte encodings"
}, {
encodings: [ {
labels: [ "chinese", "csgb2312", "csiso58gb231280", "gb2312", "gb_2312", "gb_2312-80", "gbk", "iso-ir-58", "x-gbk" ],
name: "GBK"
}, {
labels: [ "gb18030" ],
name: "gb18030"
} ],
heading: "Legacy multi-byte Chinese (simplified) encodings"
}, {
encodings: [ {
labels: [ "big5", "big5-hkscs", "cn-big5", "csbig5", "x-x-big5" ],
name: "Big5"
} ],
heading: "Legacy multi-byte Chinese (traditional) encodings"
}, {
encodings: [ {
labels: [ "cseucpkdfmtjapanese", "euc-jp", "x-euc-jp" ],
name: "EUC-JP"
}, {
labels: [ "csiso2022jp", "iso-2022-jp" ],
name: "ISO-2022-JP"
}, {
labels: [ "csshiftjis", "ms932", "ms_kanji", "shift-jis", "shift_jis", "sjis", "windows-31j", "x-sjis" ],
name: "Shift_JIS"
} ],
heading: "Legacy multi-byte Japanese encodings"
}, {
encodings: [ {
labels: [ "cseuckr", "csksc56011987", "euc-kr", "iso-ir-149", "korean", "ks_c_5601-1987", "ks_c_5601-1989", "ksc5601", "ksc_5601", "windows-949" ],
name: "EUC-KR"
} ],
heading: "Legacy multi-byte Korean encodings"
}, {
encodings: [ {
labels: [ "csiso2022kr", "hz-gb-2312", "iso-2022-cn", "iso-2022-cn-ext", "iso-2022-kr" ],
name: "replacement"
}, {
labels: [ "utf-16be" ],
name: "UTF-16BE"
}, {
labels: [ "utf-16", "utf-16le" ],
name: "UTF-16LE"
}, {
labels: [ "x-user-defined" ],
name: "x-user-defined"
} ],
heading: "Legacy miscellaneous encodings"
} ], p = {};
g.forEach(function(n) {
n.encodings.forEach(function(n) {
n.labels.forEach(function(e) {
p[e] = n;
});
});
});
var _, b, w = {}, m = {};
function v(n, e) {
return e && e[n] || null;
}
function y(n, e) {
var r = e.indexOf(n);
return -1 === r ? null : r;
}
function x(e) {
if (!("encoding-indexes" in n)) throw Error("Indexes missing. Did you forget to include encoding-indexes.js first?");
return n["encoding-indexes"][e];
}
function O(n) {
if (n > 39419 && n < 189e3 || n > 1237575) return null;
if (7457 === n) return 59335;
var e, r = 0, i = 0, t = x("gb18030-ranges");
for (e = 0; e < t.length; ++e) {
var o = t[e];
if (!(o[0] <= n)) break;
r = o[0];
i = o[1];
}
return i + n - r;
}
function k(n) {
if (59335 === n) return 7457;
var e, r = 0, i = 0, t = x("gb18030-ranges");
for (e = 0; e < t.length; ++e) {
var o = t[e];
if (!(o[1] <= n)) break;
r = o[1];
i = o[0];
}
return i + n - r;
}
function E(n) {
return (_ = _ || x("jis0208").map(function(n, r) {
return e(r, 8272, 8835) ? null : n;
})).indexOf(n);
}
function j(n) {
var e = b = b || x("big5").map(function(n, e) {
return e < 5024 ? null : n;
});
return 9552 === n || 9566 === n || 9569 === n || 9578 === n || 21313 === n || 21317 === n ? e.lastIndexOf(n) : y(n, e);
}
var B = "utf-8";
function S(n, e) {
if (!(this instanceof S)) throw TypeError("Called as a function. Did you forget 'new'?");
n = void 0 !== n ? String(n) : B;
e = i(e);
this._encoding = null;
this._decoder = null;
this._ignoreBOM = !1;
this._BOMseen = !1;
this._error_mode = "replacement";
this._do_not_flush = !1;
var r = h(n);
if (null === r || "replacement" === r.name) throw RangeError("Unknown encoding: " + n);
if (!m[r.name]) throw Error("Decoder not present. Did you forget to include encoding-indexes.js first?");
this._encoding = r;
Boolean(e.fatal) && (this._error_mode = "fatal");
Boolean(e.ignoreBOM) && (this._ignoreBOM = !0);
if (!Object.defineProperty) {
this.encoding = this._encoding.name.toLowerCase();
this.fatal = "fatal" === this._error_mode;
this.ignoreBOM = this._ignoreBOM;
}
return this;
}
if (Object.defineProperty) {
Object.defineProperty(S.prototype, "encoding", {
get: function() {
return this._encoding.name.toLowerCase();
}
});
Object.defineProperty(S.prototype, "fatal", {
get: function() {
return "fatal" === this._error_mode;
}
});
Object.defineProperty(S.prototype, "ignoreBOM", {
get: function() {
return this._ignoreBOM;
}
});
}
S.prototype.decode = function(n, e) {
var r;
r = "object" == typeof n && n instanceof ArrayBuffer ? new Uint8Array(n) : "object" == typeof n && "buffer" in n && n.buffer instanceof ArrayBuffer ? new Uint8Array(n.buffer, n.byteOffset, n.byteLength) : new Uint8Array(0);
e = i(e);
if (!this._do_not_flush) {
this._decoder = m[this._encoding.name]({
fatal: "fatal" === this._error_mode
});
this._BOMseen = !1;
}
this._do_not_flush = Boolean(e.stream);
for (var t, s = new l(r), u = []; ;) {
var c = s.read();
if (c === a) break;
if ((t = this._decoder.handler(s, c)) === f) break;
null !== t && (Array.isArray(t) ? u.push.apply(u, t) : u.push(t));
}
if (!this._do_not_flush) {
do {
if ((t = this._decoder.handler(s, s.read())) === f) break;
null !== t && (Array.isArray(t) ? u.push.apply(u, t) : u.push(t));
} while (!s.endOfStream());
this._decoder = null;
}
return function(n) {
if ((e = [ "UTF-8", "UTF-16LE", "UTF-16BE" ], r = this._encoding.name, -1 !== e.indexOf(r)) && !this._ignoreBOM && !this._BOMseen) if (n.length > 0 && 65279 === n[0]) {
this._BOMseen = !0;
n.shift();
} else n.length > 0 && (this._BOMseen = !0);
var e, r;
return o(n);
}.call(this, u);
};
function T(e, r) {
if (!(this instanceof T)) throw TypeError("Called as a function. Did you forget 'new'?");
r = i(r);
this._encoding = null;
this._encoder = null;
this._do_not_flush = !1;
this._fatal = Boolean(r.fatal) ? "fatal" : "replacement";
if (Boolean(r.NONSTANDARD_allowLegacyEncoding)) {
var t = h(e = void 0 !== e ? String(e) : B);
if (null === t || "replacement" === t.name) throw RangeError("Unknown encoding: " + e);
if (!w[t.name]) throw Error("Encoder not present. Did you forget to include encoding-indexes.js first?");
this._encoding = t;
} else {
this._encoding = h("utf-8");
void 0 !== e && "console" in n && console.warn("TextEncoder constructor called with encoding label, which is ignored.");
}
Object.defineProperty || (this.encoding = this._encoding.name.toLowerCase());
return this;
}
Object.defineProperty && Object.defineProperty(T.prototype, "encoding", {
get: function() {
return this._encoding.name.toLowerCase();
}
});
T.prototype.encode = function(n, e) {
n = void 0 === n ? "" : String(n);
e = i(e);
this._do_not_flush || (this._encoder = w[this._encoding.name]({
fatal: "fatal" === this._fatal
}));
this._do_not_flush = Boolean(e.stream);
for (var r, o = new l(t(n)), s = []; ;) {
var u = o.read();
if (u === a) break;
if ((r = this._encoder.handler(o, u)) === f) break;
Array.isArray(r) ? s.push.apply(s, r) : s.push(r);
}
if (!this._do_not_flush) {
for (;(r = this._encoder.handler(o, o.read())) !== f; ) Array.isArray(r) ? s.push.apply(s, r) : s.push(r);
this._encoder = null;
}
return new Uint8Array(s);
};
function I(n) {
var r = n.fatal, i = 0, t = 0, o = 0, s = 128, u = 191;
this.handler = function(n, l) {
if (l === a && 0 !== o) {
o = 0;
return c(r);
}
if (l === a) return f;
if (0 === o) {
if (e(l, 0, 127)) return l;
if (e(l, 194, 223)) {
o = 1;
i = 31 & l;
} else if (e(l, 224, 239)) {
224 === l && (s = 160);
237 === l && (u = 159);
o = 2;
i = 15 & l;
} else {
if (!e(l, 240, 244)) return c(r);
240 === l && (s = 144);
244 === l && (u = 143);
o = 3;
i = 7 & l;
}
return null;
}
if (!e(l, s, u)) {
i = o = t = 0;
s = 128;
u = 191;
n.prepend(l);
return c(r);
}
s = 128;
u = 191;
i = i << 6 | 63 & l;
if ((t += 1) !== o) return null;
var d = i;
i = o = t = 0;
return d;
};
}
function U(n) {
n.fatal;
this.handler = function(n, r) {
if (r === a) return f;
if (u(r)) return r;
var i, t;
if (e(r, 128, 2047)) {
i = 1;
t = 192;
} else if (e(r, 2048, 65535)) {
i = 2;
t = 224;
} else if (e(r, 65536, 1114111)) {
i = 3;
t = 240;
}
for (var o = [ (r >> 6 * i) + t ]; i > 0; ) {
var s = r >> 6 * (i - 1);
o.push(128 | 63 & s);
i -= 1;
}
return o;
};
}
w["UTF-8"] = function(n) {
return new U(n);
};
m["UTF-8"] = function(n) {
return new I(n);
};
function C(n, e) {
var r = e.fatal;
this.handler = function(e, i) {
if (i === a) return f;
if (s(i)) return i;
var t = n[i - 128];
return null === t ? c(r) : t;
};
}
function A(n, e) {
e.fatal;
this.handler = function(e, r) {
if (r === a) return f;
if (u(r)) return r;
var i = y(r, n);
null === i && d(r);
return i + 128;
};
}
"encoding-indexes" in n && g.forEach(function(n) {
"Legacy single-byte encodings" === n.heading && n.encodings.forEach(function(n) {
var e = n.name, r = x(e.toLowerCase());
m[e] = function(n) {
return new C(r, n);
};
w[e] = function(n) {
return new A(r, n);
};
});
});
m.GBK = function(n) {
return new L(n);
};
w.GBK = function(n) {
return new M(n, !0);
};
function L(n) {
var r = n.fatal, i = 0, t = 0, o = 0;
this.handler = function(n, u) {
if (u === a && 0 === i && 0 === t && 0 === o) return f;
if (u === a && (0 !== i || 0 !== t || 0 !== o)) {
i = 0;
t = 0;
o = 0;
c(r);
}
var l;
if (0 !== o) {
l = null;
e(u, 48, 57) && (l = O(10 * (126 * (10 * (i - 129) + t - 48) + o - 129) + u - 48));
var d = [ t, o, u ];
i = 0;
t = 0;
o = 0;
if (null === l) {
n.prepend(d);
return c(r);
}
return l;
}
if (0 !== t) {
if (e(u, 129, 254)) {
o = u;
return null;
}
n.prepend([ t, u ]);
i = 0;
t = 0;
return c(r);
}
if (0 !== i) {
if (e(u, 48, 57)) {
t = u;
return null;
}
var h = i, g = null;
i = 0;
var p = u < 127 ? 64 : 65;
(e(u, 64, 126) || e(u, 128, 254)) && (g = 190 * (h - 129) + (u - p));
null === (l = null === g ? null : v(g, x("gb18030"))) && s(u) && n.prepend(u);
return null === l ? c(r) : l;
}
if (s(u)) return u;
if (128 === u) return 8364;
if (e(u, 129, 254)) {
i = u;
return null;
}
return c(r);
};
}
function M(n, e) {
n.fatal;
this.handler = function(n, i) {
if (i === a) return f;
if (u(i)) return i;
if (58853 === i) return d(i);
if (e && 8364 === i) return 128;
var t = y(i, x("gb18030"));
if (null !== t) {
var o = t % 190;
return [ r(t / 190) + 129, o + (o < 63 ? 64 : 65) ];
}
if (e) return d(i);
t = k(i);
var s = r(t / 10 / 126 / 10), l = r((t -= 12600 * s) / 10 / 126), c = r((t -= 1260 * l) / 10);
return [ s + 129, l + 48, c + 129, t - 10 * c + 48 ];
};
}
w.gb18030 = function(n) {
return new M(n);
};
m.gb18030 = function(n) {
return new L(n);
};
function P(n) {
var r = n.fatal, i = 0;
this.handler = function(n, t) {
if (t === a && 0 !== i) {
i = 0;
return c(r);
}
if (t === a && 0 === i) return f;
if (0 !== i) {
var o = i, u = null;
i = 0;
var l = t < 127 ? 64 : 98;
(e(t, 64, 126) || e(t, 161, 254)) && (u = 157 * (o - 129) + (t - l));
switch (u) {
case 1133:
return [ 202, 772 ];

case 1135:
return [ 202, 780 ];

case 1164:
return [ 234, 772 ];

case 1166:
return [ 234, 780 ];
}
var d = null === u ? null : v(u, x("big5"));
null === d && s(t) && n.prepend(t);
return null === d ? c(r) : d;
}
if (s(t)) return t;
if (e(t, 129, 254)) {
i = t;
return null;
}
return c(r);
};
}
function D(n) {
n.fatal;
this.handler = function(n, e) {
if (e === a) return f;
if (u(e)) return e;
var i = j(e);
if (null === i) return d(e);
var t = r(i / 157) + 129;
if (t < 161) return d(e);
var o = i % 157;
return [ t, o + (o < 63 ? 64 : 98) ];
};
}
w.Big5 = function(n) {
return new D(n);
};
m.Big5 = function(n) {
return new P(n);
};
function F(n) {
var r = n.fatal, i = !1, t = 0;
this.handler = function(n, o) {
if (o === a && 0 !== t) {
t = 0;
return c(r);
}
if (o === a && 0 === t) return f;
if (142 === t && e(o, 161, 223)) {
t = 0;
return 65216 + o;
}
if (143 === t && e(o, 161, 254)) {
i = !0;
t = o;
return null;
}
if (0 !== t) {
var u = t;
t = 0;
var l = null;
e(u, 161, 254) && e(o, 161, 254) && (l = v(94 * (u - 161) + (o - 161), x(i ? "jis0212" : "jis0208")));
i = !1;
e(o, 161, 254) || n.prepend(o);
return null === l ? c(r) : l;
}
if (s(o)) return o;
if (142 === o || 143 === o || e(o, 161, 254)) {
t = o;
return null;
}
return c(r);
};
}
function J(n) {
n.fatal;
this.handler = function(n, i) {
if (i === a) return f;
if (u(i)) return i;
if (165 === i) return 92;
if (8254 === i) return 126;
if (e(i, 65377, 65439)) return [ 142, i - 65377 + 161 ];
8722 === i && (i = 65293);
var t = y(i, x("jis0208"));
return null === t ? d(i) : [ r(t / 94) + 161, t % 94 + 161 ];
};
}
w["EUC-JP"] = function(n) {
return new J(n);
};
m["EUC-JP"] = function(n) {
return new F(n);
};
function K(n) {
var r = n.fatal, i = 0, t = 0, o = !1;
this.handler = function(n, s) {
switch (i) {
default:
case 0:
if (27 === s) {
i = 5;
return null;
}
if (e(s, 0, 127) && 14 !== s && 15 !== s && 27 !== s) {
o = !1;
return s;
}
if (s === a) return f;
o = !1;
return c(r);

case 1:
if (27 === s) {
i = 5;
return null;
}
if (92 === s) {
o = !1;
return 165;
}
if (126 === s) {
o = !1;
return 8254;
}
if (e(s, 0, 127) && 14 !== s && 15 !== s && 27 !== s && 92 !== s && 126 !== s) {
o = !1;
return s;
}
if (s === a) return f;
o = !1;
return c(r);

case 2:
if (27 === s) {
i = 5;
return null;
}
if (e(s, 33, 95)) {
o = !1;
return 65344 + s;
}
if (s === a) return f;
o = !1;
return c(r);

case 3:
if (27 === s) {
i = 5;
return null;
}
if (e(s, 33, 126)) {
o = !1;
t = s;
i = 4;
return null;
}
if (s === a) return f;
o = !1;
return c(r);

case 4:
if (27 === s) {
i = 5;
return c(r);
}
if (e(s, 33, 126)) {
i = 3;
var u = v(94 * (t - 33) + s - 33, x("jis0208"));
return null === u ? c(r) : u;
}
if (s === a) {
i = 3;
n.prepend(s);
return c(r);
}
i = 3;
return c(r);

case 5:
if (36 === s || 40 === s) {
t = s;
i = 6;
return null;
}
n.prepend(s);
o = !1;
i = 0;
return c(r);

case 6:
var l = t;
t = 0;
var d = null;
40 === l && 66 === s && (d = 0);
40 === l && 74 === s && (d = 1);
40 === l && 73 === s && (d = 2);
36 !== l || 64 !== s && 66 !== s || (d = 3);
if (null !== d) {
i = i = d;
var h = o;
o = !0;
return h ? c(r) : null;
}
n.prepend([ l, s ]);
o = !1;
i = 0;
return c(r);
}
};
}
function R(n) {
n.fatal;
var e = 0;
this.handler = function(n, i) {
if (i === a && 0 !== e) {
n.prepend(i);
e = 0;
return [ 27, 40, 66 ];
}
if (i === a && 0 === e) return f;
if (!(0 !== e && 1 !== e || 14 !== i && 15 !== i && 27 !== i)) return d(65533);
if (0 === e && u(i)) return i;
if (1 === e && (u(i) && 92 !== i && 126 !== i || 165 == i || 8254 == i)) {
if (u(i)) return i;
if (165 === i) return 92;
if (8254 === i) return 126;
}
if (u(i) && 0 !== e) {
n.prepend(i);
e = 0;
return [ 27, 40, 66 ];
}
if ((165 === i || 8254 === i) && 1 !== e) {
n.prepend(i);
e = 1;
return [ 27, 40, 74 ];
}
8722 === i && (i = 65293);
var t = y(i, x("jis0208"));
if (null === t) return d(i);
if (2 !== e) {
n.prepend(i);
e = 2;
return [ 27, 36, 66 ];
}
return [ r(t / 94) + 33, t % 94 + 33 ];
};
}
w["ISO-2022-JP"] = function(n) {
return new R(n);
};
m["ISO-2022-JP"] = function(n) {
return new K(n);
};
function G(n) {
var r = n.fatal, i = 0;
this.handler = function(n, t) {
if (t === a && 0 !== i) {
i = 0;
return c(r);
}
if (t === a && 0 === i) return f;
if (0 !== i) {
var o = i, u = null;
i = 0;
var l = t < 127 ? 64 : 65, d = o < 160 ? 129 : 193;
(e(t, 64, 126) || e(t, 128, 252)) && (u = 188 * (o - d) + t - l);
if (e(u, 8836, 10715)) return 48508 + u;
var h = null === u ? null : v(u, x("jis0208"));
null === h && s(t) && n.prepend(t);
return null === h ? c(r) : h;
}
if (s(t) || 128 === t) return t;
if (e(t, 161, 223)) return 65216 + t;
if (e(t, 129, 159) || e(t, 224, 252)) {
i = t;
return null;
}
return c(r);
};
}
function N(n) {
n.fatal;
this.handler = function(n, i) {
if (i === a) return f;
if (u(i) || 128 === i) return i;
if (165 === i) return 92;
if (8254 === i) return 126;
if (e(i, 65377, 65439)) return i - 65377 + 161;
8722 === i && (i = 65293);
var t = E(i);
if (null === t) return d(i);
var o = r(t / 188), s = t % 188;
return [ o + (o < 31 ? 129 : 193), s + (s < 63 ? 64 : 65) ];
};
}
w.Shift_JIS = function(n) {
return new N(n);
};
m.Shift_JIS = function(n) {
return new G(n);
};
function q(n) {
var r = n.fatal, i = 0;
this.handler = function(n, t) {
if (t === a && 0 !== i) {
i = 0;
return c(r);
}
if (t === a && 0 === i) return f;
if (0 !== i) {
var o = i, u = null;
i = 0;
e(t, 65, 254) && (u = 190 * (o - 129) + (t - 65));
var l = null === u ? null : v(u, x("euc-kr"));
null === u && s(t) && n.prepend(t);
return null === l ? c(r) : l;
}
if (s(t)) return t;
if (e(t, 129, 254)) {
i = t;
return null;
}
return c(r);
};
}
function z(n) {
n.fatal;
this.handler = function(n, e) {
if (e === a) return f;
if (u(e)) return e;
var i = y(e, x("euc-kr"));
return null === i ? d(e) : [ r(i / 190) + 129, i % 190 + 65 ];
};
}
w["EUC-KR"] = function(n) {
return new z(n);
};
m["EUC-KR"] = function(n) {
return new q(n);
};
function H(n, e) {
var r = n >> 8, i = 255 & n;
return e ? [ r, i ] : [ i, r ];
}
function Q(n, r) {
var i = r.fatal, t = null, o = null;
this.handler = function(r, s) {
if (s === a && (null !== t || null !== o)) return c(i);
if (s === a && null === t && null === o) return f;
if (null === t) {
t = s;
return null;
}
var u;
u = n ? (t << 8) + s : (s << 8) + t;
t = null;
if (null !== o) {
var l = o;
o = null;
if (e(u, 56320, 57343)) return 65536 + 1024 * (l - 55296) + (u - 56320);
r.prepend(H(u, n));
return c(i);
}
if (e(u, 55296, 56319)) {
o = u;
return null;
}
return e(u, 56320, 57343) ? c(i) : u;
};
}
function V(n, r) {
r.fatal;
this.handler = function(r, i) {
if (i === a) return f;
if (e(i, 0, 65535)) return H(i, n);
var t = H(55296 + (i - 65536 >> 10), n), o = H(56320 + (i - 65536 & 1023), n);
return t.concat(o);
};
}
w["UTF-16BE"] = function(n) {
return new V(!0, n);
};
m["UTF-16BE"] = function(n) {
return new Q(!0, n);
};
w["UTF-16LE"] = function(n) {
return new V(!1, n);
};
m["UTF-16LE"] = function(n) {
return new Q(!1, n);
};
function W(n) {
n.fatal;
this.handler = function(n, e) {
return e === a ? f : s(e) ? e : 63360 + e - 128;
};
}
function X(n) {
n.fatal;
this.handler = function(n, r) {
return r === a ? f : u(r) ? r : e(r, 63360, 63487) ? r - 63360 + 128 : d(r);
};
}
w["x-user-defined"] = function(n) {
return new X(n);
};
m["x-user-defined"] = function(n) {
return new W(n);
};
n.TextEncoder || (n.TextEncoder = T);
n.TextDecoder || (n.TextDecoder = S);
"undefined" != typeof module && module.exports && (module.exports = {
TextEncoder: n.TextEncoder,
TextDecoder: n.TextDecoder,
EncodingIndexes: n["encoding-indexes"]
});
})(this || {});